#include <errno.h>
#include <string.h>

#include <libpv.h>
#include <pv_types.h>
#include <pv_bs.h>

/*
 * this functions flushes!
 */
int pv_default(pv_engine_t *engine_anon, void *pv_var)
{
	struct pv_engine	*engine = (struct pv_engine *)engine_anon;
	struct pv		*pv;
	int			finished = 0;

	for (goto_head(&engine->pv_list); !finished; goto_next(&engine->pv_list)) {
		
		if (is_last(engine->pv_list))
			finished=1;

		pv = (struct pv *)list_get_element_data(engine->pv_list);
		if (pv_var == NULL
		    || (engine->store.map + pv->offset) == pv_var) {
			union pv_data	*data = engine->store.map + pv->offset;

			switch (pv->type) {
			case pv_type_int8:
				*data->i8 = pv->dflt.i8;
				break;
			case pv_type_uint8:
				*data->u8 = pv->dflt.u8;
				break;

			case pv_type_int16:
				*data->i16 = pv->dflt.i16;
				break;
			case pv_type_uint16:
				*data->u16 = pv->dflt.u16;
				break;

			case pv_type_int32:
				*data->i32 = pv->dflt.i32;
				break;
			case pv_type_uint32:
				*data->u32 = pv->dflt.u32;
				break;

			case pv_type_int64:
				*data->i64 = pv->dflt.i64;
				break;
			case pv_type_uint64:
				*data->u64 = pv->dflt.u64;
				break;

			case pv_type_string:
				memcpy(data->string, pv->dflt.string, pv->size);
				break;

			case pv_type_undef:
				break;
			}

			if (pv_var != NULL) {
				pv_bs_flush(engine, pv_var, pv->size);
				return 0;
			}
		}
	}

	if (pv_var == NULL) {
		pv_bs_flush_all(engine);
		return 0;
	}

	return -EINVAL;
}
