#include <string.h>

#include <libpv.h>
#include <pv_types.h>

uint8_t *pv_register_uint8(pv_engine_t	*pv_engine_anon,
			   const char	*id)
{
	struct pv_engine	*pv_engine = (struct pv_engine *)pv_engine_anon;
	struct pv		*pv;
	uint8_t			*ret = NULL;
	int			finished = 0; 

	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {
		pv = (struct pv *)list_get_element_data(pv_engine->pv_list);
			
		if (is_last(pv_engine->pv_list))
			finished=1;

		if (!strcmp(id, pv->id)) {
			ret = (uint8_t *)(pv_engine->store.map + pv->offset);
			break; 
		}
	}

	return ret;
}


uint16_t *pv_register_uint16(pv_engine_t	*pv_engine_anon,
			     const char		*id)
{
	struct pv_engine	*pv_engine = (struct pv_engine *)pv_engine_anon;
	struct pv		*pv;
	uint16_t		*ret = NULL;
	int			finished = 0; 

	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {
		pv = (struct pv *)list_get_element_data(pv_engine->pv_list);
		
		if (is_last(pv_engine->pv_list))
			finished=1;
		
		if (!strcmp(id, pv->id)) {
			ret = (uint16_t *)(pv_engine->store.map + pv->offset);
			break; 
		}
	}

	return ret;
}


uint32_t *pv_register_uint32(pv_engine_t	*pv_engine_anon,
			     const char		*id)
{
	struct pv_engine	*pv_engine = (struct pv_engine *)pv_engine_anon;
	struct pv		*pv;
	uint32_t		*ret = NULL;
	int			finished = 0; 

	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {
		if (is_last(pv_engine->pv_list))
			finished=1;

		pv = (struct pv *)list_get_element_data(pv_engine->pv_list);
		if (!strcmp(id, pv->id)) {
			ret = (uint32_t *)(pv_engine->store.map + pv->offset);
			break; 
		}
	}

	return ret;
}


char *pv_register_string(pv_engine_t	*pv_engine_anon,
			 const char	*id)
{
	struct pv_engine	*pv_engine = (struct pv_engine *)pv_engine_anon;
	struct pv		*pv;
	char			*ret = NULL;
	int			finished = 0; 

	for (goto_head(&pv_engine->pv_list); !finished; goto_next(&pv_engine->pv_list)) {
		if (is_last(pv_engine->pv_list))
			finished=1;

		pv = (struct pv *)list_get_element_data(pv_engine->pv_list);
		if (!strcmp(id, pv->id)) {
			ret = (char *)(pv_engine->store.map + pv->offset);
			break; 
		}
	}

	return ret;
}
